program LMO_PW
  use SEP
  implicit none
  integer                              :: n1,n2,m1,m2,pad2,ix,iw,jj
  real                                 :: o1,o2,d1,d2,xloc,angle,w0,w,dw,vel
  real                                 :: ang,pi,sig1,dx,p1
  real   , dimension(:,:), allocatable :: data,modl
  real   , dimension(:,:), allocatable :: tmp
  complex, dimension(:,:), allocatable :: cdata,cmodl
  call sep_init()
  call from_history("n1",n1          )
  call from_history("n2",n2          )
  call from_history("o1",o1          )
  call from_history("o2",o2          )
  call from_history("d1",d1          )
  call from_history("d2",d2          )
  call from_param  ("vel",vel        )
  call from_param  ("ang",ang        )          
  call auxputch  ("n1","i",n1,"rr.H" )
  call auxputch  ("n2","i",n2,"rr.H" )
  call auxputch  ("o1","r",o1,"rr.H" )
  call auxputch  ("o2","r",o2,"rr.H" )
  call auxputch  ("d1","r",d1,"rr.H" )
  call auxputch  ("d2","r",d2,"rr.H" )
  call auxputch  ("n1","i",n1,"ii.H" )
  call auxputch  ("n2","i",n2,"ii.H" )
  call auxputch  ("o1","r",o1,"ii.H" )
  call auxputch  ("o2","r",o2,"ii.H" )
  call auxputch  ("d1","r",d1,"ii.H" )
  call auxputch  ("d2","r",d2,"ii.H" )
  call hclose()
  m1=pad2(n1)
  m2=pad2(n2)
  allocate(  data(n1,n2), modl(m1,m2) )
  allocate( cdata(m1,m2),cmodl(m1,m2) )
  pi = acos(-1.); sig1 = +1.;
  w0=-pi/d1;  dw=2.*pi/(m1*d1);

  call sep_read( data )
  cdata(1:n1,1:n2)=cmplx(data,0.)

  angle=ang/180.*pi
  p1=sin(angle)/vel

  call ft1axis(0,sig1,m1,n2,cdata)
  do ix=1,n2
     xloc=(ix-1)*d2
     do iw=1,m1
        w=w0+(iw-1)*dw
        if (ang .lt. 0.) then
           cmodl(iw,ix)=cdata(iw,ix)*exp(cmplx(0.,w*p1*((n2-1)*d2-xloc)*tan(angle)))
        else
           cmodl(iw,ix)=cdata(iw,ix)*exp(cmplx(0.,w*p1*xloc*tan(angle)))
        end if
     end do
  end do
  call ft1axis(1,sig1,m1,n2,cmodl)

  modl= real(cmodl(1:n1,1:n2))
  call  sep_write(modl,"rr.H")
  modl=aimag(cmodl(1:n1,1:n2))
  call  sep_write(modl,"ii.H")

  deallocate(data,cdata,modl,cmodl)
end program LMO_PW
