program MakePotential
  use sep
  implicit none
  integer                           :: n1,n2
  real                              :: d1,d2,o1,o2
  real,  dimension(:,:),allocatable :: dxdt,dxdg
  real,  dimension(:,:),allocatable :: data,model

  call sep_init()
  call from_history("n1",n1)
  call from_history("d1",d1)
  call from_history("o1",o1)
  call from_history("n2",n2)
  call from_history("d2",d2)
  call from_history("o2",o2)
  call to_history("n1",n1)
  call to_history("d1",d1)
  call to_history("o1",o1)
  call to_history("n2",n2)
  call to_history("d2",d2)
  call to_history("o2",o2)

  call from_aux("vel","n1",nvz          ) 
  call from_aux("vel","d1",dvz1         )
  call from_aux("vel","o1",ovz1         )
  call from_aux("vel","n2",nvx          ) 
  call from_aux("vel","d2",dvx1         )
  call from_aux("vel","o2",ovx1         ) 
  call sep_close()

  allocate(   data(n1,n2),model(n1,n2),dxdt(n1,n2), dxdg(n1,n2) )
  call sep_read(data)

  dxdt(2:n1-1,:)=(data(3:n1,:)-data(1:n1-2,:))/(2.*d1)
  dxdt(1 ,:)=dxdt(2   ,:)
  dxdt(n1,:)=dxdt(n1-1,:)

  dxdg(:,2:n2-1)=(data(:,3:n2)-data(:,1:n2-2))/(2.*d2)
  dxdg(:,1 )=dxdg(:,2   )
  dxdg(:,n2)=dxdg(:,n2-1)

  model=dxdt*d1+dxdg*d2

  call sep_write(model)
  call exit(0)
end program MakePotential









