program C2Rsinc_stat
  !! interpolates from cartesian coordinates to ray coordinates
  !! using sinc interpolation
  !! Paul Sava (paul@sep.stanford.edu)
  !! 08/15/03
  use sep
  !!use utilspaul
  use utils_ 
  implicit none
  character(len=128) :: name
  logical            :: adj
  real               :: gx,gz
  real,    pointer   :: mapCC(:,:),mapRC(:,:,:),JJ(:,:),mapRCC(:,:)
  real,    pointer   :: fold(:,:)
  complex, pointer   :: rays(:,:)
  real,    pointer   :: xxx(:,:),zzz(:,:)
  type(myaxis) :: ax,az,at,ag,an
  integer      :: ix,iz,it,ig,in,jx,jz,nsz,nsx
  real         :: x,z,zz,xx,dz,dx,r,sincr,dr
  integer      :: norm
  call sep_init()
  call from_param("adj",adj,.false.)
  call from_param("nsz",nsz,5)
  call from_param("nsx",nsx,5)
  name="rays"
  call ainaxis(at,1,name)
  call ainaxis(ag,2,name)
  call ainaxis(an,3,name)

  if(adj) then
     az%l="az"
     call printaxis(az)
     call pinaxis(az)
     call printaxis(az)
     ax%l="ax"
     call printaxis(ax)
     call pinaxis(ax)
     call printaxis(ax)
     call houaxis(az,1)
     call houaxis(ax,2)
  else
     call hinaxis(az,1)
     call hinaxis(ax,2)
     call houaxis(at,1)
     call houaxis(ag,2)
     call houaxis(an,3)
  end if 

  call sep_close()

  allocate(mapCC (az%n,ax%n)); mapCC=0.
  allocate(mapRC (at%n,ag%n,an%n)); mapRC=0.
  allocate(mapRCC(at%n,ag%n)); mapRCC=0.
  allocate( fold (az%n,ax%n)); fold =0.
  allocate( rays (at%n,ag%n)); rays =0.
  allocate(  xxx (at%n,ag%n)); xxx  =0.
  allocate(  zzz (at%n,ag%n)); zzz  =0.
  allocate(   JJ (at%n,ag%n)); JJ   =0.

  call sreed("rays",rays,size(rays)*8)
  if(adj) then
     call sreed("in" ,mapRC,size(mapRC)*4)
  else
     call sreed("in" ,mapCC,size(mapCC)*4)
  end if
  dr = sqrt(az%d**2 + ax%d**2)

  !! . . Calculate Jacobian normalization factors
  xxx=real(rays)
  zzz=aimag(rays)
  do it=1,at%n
     do ig=2,ag%n-1
        gx = (xxx(it,ig+1)-xxx(it,ig-1))/(2.*ag%d)
        gz = (zzz(it,ig+1)-zzz(it,ig-1))/(2.*ag%d)
        JJ(it,ig) = sqrt(1./(gx*gx + gz*gz))
     end do
  end do
  JJ(:,1)    = JJ(:,2)
  JJ(:,ag%n) = JJ(:,ag%n-1)
  JJ(1,:)    = JJ(2,:)
  JJ(at%n,:) = JJ(at%n-1,:)

  do in=1,an%n
     mapRCC=mapRC(:,:,in)/(JJ**1)

     do ig=1,ag%n
        if(mod(ig,100)==0) write(0,*) ig,ag%n
        do it=1,at%n   
           z=aimag(rays(it,ig))
           x= real(rays(it,ig))
           iz=floor((z-az%o)/az%d)+1
           ix=floor((x-ax%o)/ax%d)+1
           if(iz<1+nsz .or. iz>az%n-nsz .or. ix<1+nsx .or. ix>ax%n-nsx) cycle

           do jz=iz-nsz,iz+nsz
              zz=az%o+(jz-1)*az%d
              dz=zz-z
              do jx=ix-nsx,ix+nsx
                 xx=ax%o+(jx-1)*ax%d
                 dx=xx-x
                 r=sqrt(dz**2 + dx**2)
                 if(abs(r)<epsilon(r)) then
                    sincr = 1.0
                 else
                    r = r / dr
                    sincr = sin(r)/r
                 end if
                 mapCC(jz,jx)  = mapCC(jz,jx)  + mapRCC(it,ig)*sincr
                 fold(jz,jx)= fold(jz,jx)+1.0 !sincr
              end do
           end do

        end do
     end do
  end do

  where (fold .gt. 0)
     mapCC=mapCC/fold
  end where
  call srite("out",mapCC,size(mapCC)*4)

  call exit(0)
end program C2Rsinc_stat






