program NewPR
  use SEP
  use newPR_mod 
  implicit none
  integer                                :: nz,nx,nw,maxnum,i2,nray,nvx,nvz
  integer                                :: iray,it
  integer,  dimension(:)                 :: ixx,izz
  real                                   :: dtau,begang,endang,dz,dx,dw,oz,ox
  real                                   :: ow,eps,mxint,mnint
  real                                   :: dvx, dvz,ovx, ovz
  complex     ,dimension(:),allocatable  :: ray_in
  real(KIND=8),dimension(:),allocatable  :: x,z,xang,zang
  real        ,dimension(:,:),allocatable:: vel_in
  real(kind=8),dimension(:,:),allocatable:: vel
  complex,  dimension(:,:),allocatable   :: Rayout,data
  logical                                :: adj,add,fromSP
  call sep_init()
  call from_history("n3",nw             )  
  call from_history("d3",dw             )  
  call from_history("o3",ow             )
  call from_aux("rays","n1",nx          )  
  call from_aux("rays","d1",dx          )  
  call from_aux("rays","o1",ox          )  
  call from_aux("vel","n1",nvz          );nz=nvz
  call from_aux("vel","d1",dvz          );dz=dvz
  call from_aux("vel","o1",ovz          );oz=ovz 
  call from_aux("vel","n2",nvx          ) 
  call from_aux("vel","d2",dvx          ) 
  call from_aux("vel","o2",ovx          )
  call from_param("adj", adj, .false.   )
  call from_param("add", add, .false.   ) 
  call from_param("eps", eps, 0.000001  )
  call from_param("maxnum",maxnum,700   )
  call from_param("begang",begang,-45.  ) 
  call from_param("endang",endang,45.   ) 
  call from_param("nray",nray,100       )
  call from_param("dtau",dtau           )
  call from_param("fromSP",fromSP,.true.)
  call from_param("mxint",mxint,5.      )
  call from_param("mnint",mnint,0.05    )
  allocate( x(nvx),z(nvz)               )
  allocate( Rayout( maxnum,nx)             )
  allocate( ixx(nvx),izz(nvz),data(nvz,nvx))
  allocate( vel(nvz,nvx),vel_in(nvz,nvx)   )
  allocate( ray_in(nray)                   )
  allocate( xang(nray),zang(nray)          )
  call sep_read( data                      )
  call sep_read( vel_in, "vel"             )
  call sep_read( ray_in, "rays"            )
  vel = dble( vel_in        )
  xang= dble( real (ray_in) )
  zang= dble( aimag(ray_in) )

  call newPR_mod_init(nz,nx,nw,dz,dx,dw,oz,ox,ow,dtau,mxint,fromSP,eps,mnint,nvz,nvx,dvz,dvx,ovz,ovx)
  ixx(1:nvx) = (/ (i2,i2=1,nvx) /)  
  izz(1:nvz) = (/ (i2,i2=1,nvz) /) 
  x=(ixx-1)*dvx+ovx               
  z=(izz-1)*dvz+ovz
  call Run_newPR_interp(vel,data,Rayout,adj,add,maxnum,x,z,xang,zang,it)
  call write_on_baby(Rayout,maxnum,it,endang,begang)
  deallocate(Rayout,xang,zang,data,vel,x,z)
end program NewPR
