program FDMdtm_
  use sep
  use util_
  use fft
  use fddtmrc_

  implicit none
  type(myaxis)            :: aw,ax,az
  character(len=128)      :: name
  integer                 :: method

  complex, pointer        :: dat(:,:)
  complex, pointer        :: wfl(:,:)
  real,    pointer        :: rcp(:,:,:)

  call sep_init()
  call from_param("method",method,1)

  call hinaxis(aw,2)
  call hinaxis(ax,1)
  name="rcp"
  call ainaxis(az,1,name)

  call houaxis(aw,2)
  call houaxis(ax,1)

  call to_history ("esize",8)
  call sep_close()

  call printaxis(az)
  call printaxis(ax)
  call printaxis(aw)

  allocate(rcp(az%n,ax%n,5))
  allocate(dat(ax%n,aw%n))
  allocate(wfl(ax%n,aw%n))

  call sep_read(dat)
  call sreed("rcp",rcp,size(rcp)*4)

  write(0,*) "a",minval(rcp(:,:,1)),maxval(rcp(:,:,1))
  write(0,*) "b",minval(rcp(:,:,2)),maxval(rcp(:,:,2))
  write(0,*) "c",minval(rcp(:,:,3)),maxval(rcp(:,:,3))
  write(0,*) "d",minval(rcp(:,:,4)),maxval(rcp(:,:,4))
  write(0,*) "s",minval(rcp(:,:,5)),maxval(rcp(:,:,5))

  ! init migration
  call fddtmrc_init(aw,ax,az)

  wfl = 0.
  call dtmrc15(dat,wfl,rcp)


  call sep_write(wfl)
  call exit (0)
end program FDMDTM_




