program IQx2
  !! Find eXtreme values in image quality maps
  !! Paul Sava (paul@sep.stanford.edu)
  !! 07/12/04

  !!  input: z-mx-my-ro (image quality map)
  !! output: z-mx-my

  use sep
  implicit none

  real, dimension(:,:,:),   allocatable :: iqmap
  real, dimension(:,:,:),   allocatable :: extrm,romax

  integer :: iro
  real    ::  ro,oro,dro
  integer :: option
  integer :: nz,nmx,nmy,nro

  call sep_init()
  call from_history("n1",nz,1)
  call from_history("n2",nmx)
  call from_history("n3",nmy)
  call from_history("n4",nro)
  call from_history("o4",oro)
  call from_history("d4",dro)

  call to_history("n4",2)
  call to_history("o4",0.)
  call to_history("d4",1.)
  call to_history("label4"," ")

  call from_param("option",option,1)
  call sep_close()

  allocate(iqmap(nz,nmx,nmy)); iqmap=1.
  allocate(extrm(nz,nmx,nmy)); extrm=0.
  allocate(romax(nz,nmx,nmy)); romax=1.

  write(0,*) option
  if(option==1) then
     extrm=0.
     romax=oro+(nro-1)*dro
  else
     extrm=1.
     romax=oro
  end if

  do iro=1,nro
     ro = oro + (iro-1)*dro
     write (0,*) "ro=",ro
     call sep_read(iqmap)

     if(option==1) then !! find max
        where (iqmap>extrm)
           extrm=iqmap
           romax=ro
        end where
     else               !! find min
        where (iqmap<extrm)
           extrm=iqmap
           romax=ro
        end where
     end if
  end do

  call sep_write(romax)
  call sep_write(extrm)

  deallocate(iqmap,extrm,romax)
  call exit(0)
end program IQX2
