program PicTop_
  !! make topography mask
  !!
  !!
  use sep
  use util_

  implicit none
  real,    pointer :: topo(:)
  real,    pointer :: velo(:,:)

  type(myaxis) :: ax,az,aa
  integer      :: ix,iz
  integer      :: jz
  real         :: vel,eps

  call sep_init()

  aa%n=1
  aa%o=0.
  aa%d=1.

  call hinaxis(az,1)
  call hinaxis(ax,2)

  call houaxis(ax,1)
  call houaxis(aa,2)

  call from_param("vel",vel,4000.)
  call from_param("eps",eps,1.)

  call to_history("esize",4)
  call sep_close()

  allocate(topo(ax%n))
  allocate(velo(az%n,ax%n))

  call sep_read(velo)

  do ix=1,ax%n

     jz=1
     do iz=1,az%n
        if( abs(velo(iz,ix)-vel)<eps) then
           jz=jz+1
        else
           cycle
        end if
     end do
     topo(ix) = az%o+(jz-1)*az%d

  end do

  call sep_write(topo)

  call exit (0)
end program PICTOP_




