program RWEmig_
  use sep
  use util_
  use wemig_

  implicit none
  type(myaxis) :: ax,az,aw,ar

  integer :: method
  integer  :: iz
  character(len=128)   :: name
  real,    allocatable :: aa(:,:),bb(:,:),mm(:,:)
  complex, allocatable :: ab(:,:)
  real,    allocatable :: a0(:,:),b0(:,:)
  complex, pointer     :: dat(:,:) !! data
  real,    pointer     :: img(:,:) !! image

  call sep_init()
  call from_param("method",method,0)

  call hinaxis(ax,1)
  call hinaxis(aw,2)
  name="abm"
  call ainaxis(az,1,name)
  name="abref"
  call ainaxis(ar,2,name)
  if(method==0) ar%n=1   !! pure finite-differences

  write(0,*) ax%n,ax%o,ax%d
  write(0,*) az%n,az%o,az%d
  write(0,*) aw%n,aw%o,aw%d
  write(0,*) ar%n,ar%o,ar%d

  call houaxis(az,1)
  call houaxis(ax,2)

  call to_history("esize",4)

  allocate(dat(ax%n,aw%n))
  allocate(img(az%n,ax%n))
  !----------------------------------------------------------------
  allocate(aa(az%n,ax%n))
  allocate(bb(az%n,ax%n))
  allocate(mm(az%n,ax%n))
  call sreed("abm",aa,size(aa)*4)
  call sreed("abm",bb,size(bb)*4)
  call sreed("abm",mm,size(mm)*4)
  write(0,*) "aa",minval(aa),maxval(aa)
  write(0,*) "bb",minval(bb),maxval(bb)
  write(0,*) "mm",minval(mm),maxval(mm)
  !----------------------------------------------------------------
  allocate(ab(az%n,ax%n))
  allocate(a0(az%n,ar%n))
  allocate(b0(az%n,ar%n))
  call sreed("abref",ab,size(ab)*8)
  a0= real(ab)
  b0=aimag(ab)
  write(0,*) "a0",minval(a0),maxval(a0)
  write(0,*) "b0",minval(b0),maxval(b0)
  !----------------------------------------------------------------
  call wemig_init(ax,az,aw,ar,method)
  call sep_read(dat)
  img=0.0
  call wemig(dat,img,aa,bb,mm,a0,b0)
  call sep_write(img)
  !----------------------------------------------------------------
  call sep_close()
  deallocate(dat,img)
end program RWEmig_
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
