program TopMsk_
  !! make topography mask
  !!
  use sep
  use util_

  implicit none
  real,    pointer :: topo(:)
  real,    pointer :: mask(:,:)

  type(myaxis) :: ax,az
  integer      :: ix,iz
  real         :: xx,zz

  logical      :: linear
  real         :: zo,fo

  call sep_init()
  call from_param("linear",linear,.true.)

  call hinaxis(ax,1)
  call from_param("nz",az%n,1)
  call from_param("oz",az%o,0.)
  call from_param("dz",az%d,1.)

  call houaxis(az,1)
  call houaxis(ax,2)

  call to_history("esize",4)
  call sep_close()

  allocate(topo(ax%n))
  allocate(mask(az%n,ax%n))

  call sep_read(topo)

  if(linear) then

     mask=0.
     do ix=1,ax%n
        zz=topo(ix)
        iz=floor((zz-az%o)/az%d+1)
        iz=maxval((/   1,iz/))
        iz=minval((/az%n,iz/))

        zo = az%o + (iz-1)*az%d
        fo = (zz-zo)/az%d

        mask(iz  ,ix) = (1.-fo)
        mask(iz+1,ix) =     fo
     end do

  else
     
     mask=0.
     do ix=1,ax%n
        zz=topo(ix)
        iz=floor((zz-az%o)/az%d+1)
        iz=maxval((/   1,iz/))
        iz=minval((/az%n,iz/))

        mask(iz  ,ix) = 1
     end do

  end if

  call sep_write(mask)

  call exit (0)
end program TOPMSK_




