#include <stdlib.h>
#include <seplib.h>
#include "basicio.h"
#include "hwt_output.h"

void read_cube(int k)
{
  int i;	/* local counting variable */
  char c[3];
  
  if(0==hetch("esize","d",&esize)) esize=4;
  
  if(esize !=4) wrerr("Unacceptable esize value \n");
  
  for(i=0;i<=k;i++) {
    nin[i]=1; nou[i]=1;
    oin[i]=0; oou[i]=0;
    din[i]=1; dou[i]=1;
  }
  
  /****************************************************************************/
  for(i=0;i<k;i++) {
    sprintf(c,"n%d",i+1);
    if(0==hetch(c,"i",&nin[i]))
      wrerr0("can not obtain n%d required for SEP datasets\n",i+1);
    
    sprintf(c,"o%d",i+1);
      if(0==hetch(c,"f",&oin[i]))
	wrerr0("can not obtain o%d required for SEP datasets\n",i+1);
      
      sprintf(c,"d%d",i+1);
      if(0==hetch(c,"f",&din[i]))
	wrerr0("can not obtain d%d required for SEP datasets\n",i+1);
  }
  /****************************************************************************/
  /* allocale a dumb vector of floats */
  datain=(float*) malloc(nin[0]*nin[1]*nin[2]*nin[3]*esize);
  if(nin[0]*nin[1]*nin[2]*nin[3]*esize != sreed("in", datain , nin[0]*nin[1]*nin[2]*nin[3]*esize))
    wrerr("trouble reading input data \n");
  
}

void write_cube(int k)
{
  int i; /* local counting variable */
  char c[3];

  /****************************************************************************/
  /* number of elements */
  for(i=0;i<k;i++) {
    sprintf(c,"n%d",k-i);
    if(0!=putch(c,"i",&nou[i]))
      wrerr0("can not write n%d into output history file\n",k-i);
   
    sprintf(c,"o%d",k-i);
    if(0!=putch(c,"f",&oou[i]))
      wrerr0("can not write o%d into output history file\n",k-i);
    
    sprintf(c,"d%d",k-i);
    if(0!=putch(c,"f",&dou[i]))
      wrerr0("can not write d%d into output history file\n",k-i);
  }
  /****************************************************************************/
  

  if(nou[0]*nou[1]*nou[2]*nou[3]*esize != srite("out", dataout, nou[0]*nou[1]*nou[2]*nou[3]*esize))
    wrerr("trouble writing output data \n");	
  
  free(datain);
  free(dataout);
  hclose();
}

