#ifndef struct3D

typedef struct {
  float x,y,z,v,t,l;
} point3D;

typedef struct {
  double dx,dy,dz;
} v3D;

typedef struct {
  point3D* point;
} ray3D;

typedef struct {
  int A_i,A_a; /* ray A */
  int B_i,B_a; /* ray B */
  int C_i,C_a; /* ray C */
} triplet;

typedef struct {
	triplet *R3;
	int nR3;
	ray3D rayA, rayB, rayC;
} triplets;

typedef struct {
  int A_i,A_a,ia; /* index A */
  int B_i,B_a,ib; /* index B */
  int C_i,C_a,ic; /* index C */
  int D_i,D_a,id; /* index D */
} tetrahedron;

typedef struct {
	tetrahedron **T4;
	int nT4;
} tetrahedra;	

typedef struct {
  float xshot,yshot,zshot; /* source coordinates */
  float aimi,aima;

  int ni;	/* number of steps in the aperture direction */
  float oi;     /* origin of the aperture direction = 0.0 */
  float si;     /* aperture step */

  int na;       /* number of steps in the radial direction */
  float oa;     /* origin of the radial direction = 0.0 */
  float sa;     /* radial step */

  int nt;
  float ot;
  float st;

	point3D ***c0;
}rays;

typedef struct { /* 1=depth 2=inline 3=xline */
  int   n1,n2,n3;
  float o1,o2,o3;
  float d1,d2,d3;
  float ***c0;
  float ***c1;
}cube;

#define struct3D structuri_in_3d
#endif







