#include <stdlib.h>
#include <seplib.h>
#include "basicio.h"
#include "hwt_global.h"
#include "hwt_struct.h"
#include "hwtiosetup.h"
#include "hwt_output.h"

void readpar_rays(rays* pRR)
{
  if(0==getch("xshot","f",&(pRR->xshot)))    wrerr("trouble obtaining xshot \n");
  if(0==getch("yshot","f",&(pRR->yshot)))    wrerr("trouble obtaining yshot \n");
  if(0==getch("zshot","f",&(pRR->zshot)))    wrerr("trouble obtaining zshot \n");
  
  if(0==getch("nt","d",&(pRR->nt)))    wrerr("trouble obtaining nt \n");
  pRR->ot=0.0;	
  if(0==getch("st","f",&(pRR->st)))    wrerr("trouble obtaining st \n");
  
  if(0==getch("aimi","f",&(pRR->aimi)))    wrerr("trouble obtaining aimi \n");
  if(0==getch("aima","f",&(pRR->aima)))    wrerr("trouble obtaining aima \n");

  if(0==getch("oi","f",&(pRR->oi)))    wrerr("trouble obtaining oi \n");
  if(0==getch("si","f",&(pRR->si)))    wrerr("trouble obtaining si \n");
  if(0==getch("ni","d",&(pRR->ni)))    wrerr("trouble obtaining ni \n");

  pRR->oa=0.0;
  if(0==getch("sa","f",&(pRR->sa)))    wrerr("trouble obtaining sa \n");
  pRR->na=360/(pRR->sa); /* from 0 to N+1 including */

  if(0==getch("wico","f",&wico))   wico=1.0;
}

void readpar_velo(cube* pVV)
{
  /* set input data */
  pVV->n1=nin[0]; pVV->o1=oin[0]; pVV->d1=din[0];
  pVV->n2=nin[1]; pVV->o2=oin[1]; pVV->d2=din[1];
  pVV->n3=nin[2]; pVV->o3=oin[2]; pVV->d3=din[2];
}

void copy_velo(cube* pVV)
{
  int idata=0;
  int i1,i2,i3;

  /* copy the velocity data in the cube */
  for(i3=0;i3<pVV->n3;i3++)
    for(i2=0;i2<pVV->n2;i2++)
      for(i1=0;i1<pVV->n1;i1++) {
	pVV->c0[i3][i2][i1]=datain[idata++];
      }
}

void write_rays(rays* pRR)
{
  int idata=0;
  int it,ii,ia;
  
  nou[0]=pRR->ni; oou[0]=pRR->oi; dou[0]=pRR->si;
  nou[1]=pRR->na; oou[1]=pRR->oa; dou[1]=pRR->sa;
  nou[2]=pRR->nt; oou[2]=pRR->ot; dou[2]=pRR->st;
  nou[3]=3;       oou[3]=0.0;     dou[3]=1.0;
  
  dataout=(float*) malloc(nou[0]*nou[1]*nou[2]*nou[3]*esize);
  
  for(ii=0;ii<pRR->ni;ii++)
    for(ia=0;ia<pRR->na;ia++)
      for(it=0;it<pRR->nt;it++) {
	dataout[idata++]=pRR->c0[ii][ia][it].x;
	dataout[idata++]=pRR->c0[ii][ia][it].y;
	dataout[idata++]=pRR->c0[ii][ia][it].z;
      }

  write_cube(4);
}

void writepar_rays(rays* pRR)
{
  if(0!=putch("xshot","f",&(pRR->xshot)))    wrerr("can't put xshot to history\n");
  if(0!=putch("yshot","f",&(pRR->yshot)))    wrerr("can't put yshot to history\n");
  if(0!=putch("zshot","f",&(pRR->zshot)))    wrerr("can't put zshot to history\n");
}

void writepar_velo(cube* pVV)
{
  if(0!=putch("nt2","d",&(pVV->n2)))    wrerr("can't put nt2 to history\n");
  if(0!=putch("nt3","d",&(pVV->n3)))    wrerr("can't put nt3 to history\n");
  if(0!=putch("nt1","d",&(pVV->n1)))    wrerr("can't put nt1 to history\n");

  if(0!=putch("ot2","f",&(pVV->o2)))    wrerr("can't put ot2 to history\n");
  if(0!=putch("ot3","f",&(pVV->o3)))    wrerr("can't put ot3 to history\n");
  if(0!=putch("ot1","f",&(pVV->o1)))    wrerr("can't put ot1 to history\n");

  if(0!=putch("dt2","f",&(pVV->d2)))    wrerr("can't put dt2 to history\n");
  if(0!=putch("dt3","f",&(pVV->d3)))    wrerr("can't put dt3 to history\n");
  if(0!=putch("dt1","f",&(pVV->d1)))    wrerr("can't put dt1 to history\n");
}









