#include <stdlib.h>
#include <seplib.h>
#include "basicio.h"
#include "hwt_global.h"
#include "hwt_struct.h"
#include "intiosetup.h"
#include "hwt_output.h"

void readpar_rays_cube(rays* pRR)
{
  pRR->nt=nin[1]; pRR->ot=oin[1]; pRR->st=din[1];
  pRR->na=nin[2]; pRR->oa=oin[2]; pRR->sa=din[2];
  pRR->ni=nin[3]; pRR->oi=oin[3]; pRR->si=din[3];
}

void readpar_time(cube* pTT)
{
  if(0==hetch("nt1","d",&(pTT->n1))) wrerr("can't get n1\n");
  if(0==hetch("nt2","d",&(pTT->n2))) wrerr("can't get n2\n");
  if(0==hetch("nt3","d",&(pTT->n3))) wrerr("can't get n3\n");

  if(0==hetch("dt1","f",&(pTT->d1))) wrerr("can't get d1\n");
  if(0==hetch("dt2","f",&(pTT->d2))) wrerr("can't get d2\n");
  if(0==hetch("dt3","f",&(pTT->d3))) wrerr("can't get d3\n");

  if(0==hetch("ot1","f",&(pTT->o1))) wrerr("can't get o1\n");
  if(0==hetch("ot2","f",&(pTT->o2))) wrerr("can't get o2\n");
  if(0==hetch("ot3","f",&(pTT->o3))) wrerr("can't get o3\n");

  if(0==getch("GL_plot","1",&GL_plot)) GL_plot=NO;
  if(0==getch("fast","1",&fast)) fast=YES;
}

void transfer_rays(rays* pRR)
{
  int it,ii,ia;
  int i_data;

  i_data=0;
  for(ii=0;ii<pRR->ni;ii++) {
    for(ia=0;ia<pRR->na;ia++) {
      for(it=0;it<pRR->nt;it++) {
	pRR->c0[ii][ia][it].x=datain[i_data++];
	pRR->c0[ii][ia][it].y=datain[i_data++];
	pRR->c0[ii][ia][it].z=datain[i_data++];
      }}}
}



void writepar_time(cube *pTT)
{
  int n4=1;
  float d4=1,o4=0;

  if(0!=putch("n1","d",&(pTT->n1))) wrerr("can't put n1\n");
  if(0!=putch("n2","d",&(pTT->n2))) wrerr("can't put n2\n");
  if(0!=putch("n3","d",&(pTT->n3))) wrerr("can't put n3\n");
  if(0!=putch("n4","d",&n4       )) wrerr("can't put n4\n");
  
  if(0!=putch("o1","f",&(pTT->o1))) wrerr("can't put o1\n");
  if(0!=putch("o2","f",&(pTT->o2))) wrerr("can't put o2\n");
  if(0!=putch("o3","f",&(pTT->o3))) wrerr("can't put o3\n");
  if(0!=putch("o4","f",&o4       )) wrerr("can't put o4\n");

  if(0!=putch("d1","f",&(pTT->d1))) wrerr("can't get d1\n");
  if(0!=putch("d2","f",&(pTT->d2))) wrerr("can't get d2\n");
  if(0!=putch("d3","f",&(pTT->d3))) wrerr("can't get d3\n");
  if(0!=putch("d4","f",&d4       )) wrerr("can't get d4\n");
}

void write_times(cube* pTT)
{
  int i1,i2,i3;
  int esize=4;
  int idata=0;

  nou[0]=pTT->n3; oou[0]=pTT->o3; dou[0]=pTT->d3;
  nou[1]=pTT->n2; oou[1]=pTT->o2; dou[1]=pTT->d2;
  nou[2]=pTT->n1; oou[2]=pTT->o1; dou[2]=pTT->d1;  

  /* allocate space for the output */
  dataout=(float*) malloc(nou[0]*nou[1]*nou[2]*esize);

  for(i3=0;i3<pTT->n3;i3++)
    for(i2=0;i2<pTT->n2;i2++)
      for(i1=0;i1<pTT->n1;i1++)
	dataout[idata++]=pTT->c0[i3][i2][i1];

  write_cube(3);
}

