/*<
tt3d

DESCRIPTION
3-D ray tracing and interpolation

USAGE
< velocity.H tt3d.x par= > rays.H

INPUT  PARAMETERS
xshot - float 
yshot - float
zshot - float

aimi  - float  aim inclination; aimi=0 is along the positive z
aima  - float  aim azimuth;     aima=0 is along the inline direction

oi    - float
ni    - int    number of steps for half aperture; 91 means 90 steps
si    - float  angular step in the aperture direction;
                (na-1)*sa=max aperture angle
sa    - float  step in the azimuth direction
                na=number of azimuthss is computed internally as na=360/sr
st    - float 
nt    - int 

AUTHOR
Paul Sava - SEP 1998
>*/

#include<sep.main>
#include "hwt_3dmain.h"
#include "hwt_global.h"
#include "hwt_output.h"
#include "basicio.h"
#include "hwtiosetup.h"
#include "intiosetup.h"
#include "hwt_alloct.h"

MAIN()
{
  rays RR;
  cube VV;
  cube TT;
  cube LL;

  wr("----------------\n");
  wr("read data  V  "); read_cube(3);              wr("OK \n");
  wr("read par   V  "); readpar_velo(&VV);         wr("OK \n");
  wr("allocate   V  "); allocate_cube(&VV);        wr("OK \n");
  wr("set        V  "); set_cube(&VV,1500.0);      wr("OK \n");
  wr("copy       V  "); copy_velo(&VV);            wr("OK \n");
  wr("----------------\n");

  TT=VV;
  LL=VV;

  wr("allocate   T  "); allocate_cube(&TT);        wr("OK \n");
  wr("allocate   L  "); allocate_cube(&LL);        wr("OK \n");
  wr("----------------\n");
  wr("read par   R  "); readpar_rays(&RR);         wr("OK \n");
  wr("allocate   R  "); allocate_rays(&RR);        wr("OK \n");
  wr("----------------\n");
  tthw3d(&RR,&VV,&TT,&LL);
  wr("----------------\n");
  wr("write par  T  "); writepar_time(&TT);        wr("OK \n");
  wr("write data T  "); write_times(&TT);          wr("OK \n");
  wr("----------------\n");
  wr("              8)\n");

  return 1;
}











