#include "wftr.h"

void raytr(int itt, int igg)
{
  point P1,P2,P3,P4;
  double a,b,c;
  double R2;
  double ALPHA,BETA;
  point Q,S1,S2; 
  double DS1,DS2;
  double LL;
  double sina,cosa,tana;
  int ss,sa;

  P2=p[itt  ][igg  ];    /* current 'middle' point */
  Q =p[itt-1][igg  ];    /* previous 'middle' point on the ray */

  LL=sqrt((P2.x-Q.x)*(P2.x-Q.x)+(P2.z-Q.z)*(P2.z-Q.z));

  if(P2.z!=Q.z) {
    tana=(P2.x-Q.x)/(P2.z-Q.z);
    ss=(tana>=0)?1:-1;
    tana=(tana>=0)?tana:-tana;
    sina=tana/sqrt(1+tana*tana);
    cosa=1/sqrt(1+tana*tana);
  }
  else {
    cosa=0;
    sina=1;
    ss=1;
  }

  /*  fprintf(stderr,"%d\n",igg);*/

  P1.x=P2.x-LL*cosa; P1.z=P2.z+ss*LL*sina; P1.v=get_xz_velocity(P1);
  P3.x=P2.x+LL*cosa; P3.z=P2.z-ss*LL*sina; P3.v=get_xz_velocity(P3);
  
  a= P1.x-P3.x    ; sa=(a>=0)?1:-1;
  b= P1.z-P3.z    ;
  c=(P1.v-P3.v)*dT;

  /*  fprintf(stderr,"%d %f %f %f \n",igg,a,b,c);*/

  R2=P2.v*dT;
  ALPHA=c/(a*a+b*b);
  BETA=sa*sqrt(a*a+b*b-c*c)/(a*a+b*b);
  
  /*  fprintf(stderr,"%d %f %f %f \n",igg,P2.x,P2.z,P2.v);*/
  /*  fprintf(stderr,"%d %f %f\n",igg,ALPHA,BETA);*/

  S1.x=P2.x-R2*(ALPHA*a-BETA*b);
  S1.z=P2.z-R2*(ALPHA*b+BETA*a);
  
  S2.x=P2.x-R2*(ALPHA*a+BETA*b);
  S2.z=P2.z-R2*(ALPHA*b-BETA*a);

  /*  fprintf(stderr,"%d %f %f\n",igg,S1.x,S2.x);*/

  DS1=distance(S1,Q);
  DS2=distance(S2,Q);

  if(DS1>DS2) P4=S1;
  else        P4=S2;

  P4.v=get_xz_velocity(P4);

  p[itt+1][igg]=P4;
}

float get_xz_velocity(point P)
{
  int iXmin, iZmin, iXmax, iZmax;
  point P1,P2,P3,P4;
  double product;
  
  if(P.x<oX)   P.x=oX;
  if(P.x>Xmax) P.x=Xmax-dX;
  
  if(P.z<oZ)   P.z=oZ;
  if(P.z>Zmax) P.z=Zmax-dZ;
  
  /*  fprintf(stderr,"%f %f \n",P.x,P.z);*/

  iXmin=(int)((P.x-oX)/dX);	if(iXmin>nX-2) iXmax=nX-1; else iXmax=iXmin+1;
  iZmin=(int)((P.z-oZ)/dZ);	if(iZmin>nZ-2) iZmax=nZ-1; else iZmax=iZmin+1;

  /* 
     2 -> 3
     
     1 <- 4
     */
  /*
  P2.x=oX+iXmin*dX;	P3.x=oX+iXmax*dX;
  P2.z=oZ+iZmin*dZ;	P3.z=oZ+iZmin*dZ;
  P2.v=V[iZmin][iXmin];	P3.v=V[iZmin][iXmax];

  P1.x=oX+iXmin*dX;	P4.x=oX+iXmax*dX;
  P1.z=oZ+iZmax*dZ;	P4.z=oZ+iZmax*dZ;
  P1.v=V[iZmax][iXmin]; P4.v=V[iZmax][iXmax];
  */
  
  P2.x=oX+iXmin*dX;     P3.x=P2.x+dX;
  P2.z=oZ+iZmin*dZ;     P3.z=P2.z   ;
  P2.v=V[iZmin][iXmin]; P3.v=V[iZmin][iXmax];

  P1.x=oX+iXmin*dX;	P4.x=P1.x+dX;
  P1.z=oZ+iZmax*dZ;	P4.z=P1.z   ;
  P1.v=V[iZmax][iXmin]; P4.v=V[iZmax][iXmax];

  product=(P.x-P1.x)*(P3.z-P1.z)-(P3.x-P1.x)*(P.z-P1.z);
  
  if(product>0)
    P.v=mixt_product(P,P1,P2,P3);	
  else
    P.v=mixt_product(P,P1,P3,P4);
  return P.v;
}

float mixt_product(point P, point P1, point P2, point P3)
{
  double mxv,mzv,mxz;
  double v;
  
  if(P1.v == P2.v && P1.v == P3.v)
    v = P1.v;
  else {
    mxv=(P2.x-P1.x)*(P3.v-P1.v)-(P3.x-P1.x)*(P2.v-P1.v);
    mzv=(P2.z-P1.z)*(P3.v-P1.v)-(P3.z-P1.z)*(P2.v-P1.v);
    mxz=(P2.x-P1.x)*(P3.z-P1.z)-(P3.x-P1.x)*(P2.z-P1.z);

    v=P1.v+( (P.z-P1.z)*mxv-(P.x-P1.x)*mzv )/mxz;
  }
  return v;
}

void wfttr(int itt, int igg)
{
  point P1,P2,P3,P4;
  double a,b,c;
  double R2;
  double ALPHA,BETA;
  point Q,S1,S2; 
  double DS1,DS2;
  int sa;

  P1=p[itt  ][igg-1];
  P2=p[itt  ][igg  ];    /* current 'middle' point */
  P3=p[itt  ][igg+1];
  Q =p[itt-1][igg  ];    /* previous 'middle' point on the ray */

  a= P1.x-P3.x    ;
  b= P1.z-P3.z    ;
  c=(P1.v-P3.v)*dT;

  sa=(a>=0)?1:-1;
  
  R2=P2.v*dT;
  ALPHA=c/(a*a+b*b);
  /*      BETA=sqrt((a*a)*(a*a+b*b-c*c))/(a*(a*a+b*b));*/
  BETA=sa*sqrt(a*a+b*b-c*c)/(a*a+b*b); 
  
  S1.x=P2.x-R2*(ALPHA*a-BETA*b);
  S1.z=P2.z-R2*(ALPHA*b+BETA*a);
  
  S2.x=P2.x-R2*(ALPHA*a+BETA*b);
  S2.z=P2.z-R2*(ALPHA*b-BETA*a);
  
  DS1=distance(S1,Q);
  DS2=distance(S2,Q);
  
  if(DS1>DS2)
    P4=S1;
  else
    P4=S2;
  
  P4.v=get_xz_velocity(P4);
  
  p[itt+1][igg]=P4;
}

int iscusp(point Q, point P1, point P2, point P3)
{
  float j1,j3;
  int sj1,sj3;

  j1=(P2.x-P1.x)*(P2.z-Q.z)-(P2.x-Q.x)*(P2.z-P1.z); sj1=(j1>=0)?1:-1;
  j3=(P2.x-P3.x)*(P2.z-Q.z)-(P2.x-Q.x)*(P2.z-P3.z); sj3=(j3>=0)?1:-1;

  if (sj1*sj3==1)
    return YES;
  else
    return NO;
}

double distance(point A, point B)
{
  return (B.x-A.x)*(B.x-A.x)+(B.z-A.z)*(B.z-A.z);
}















