! gradient in one dimension

module igrad1  

  use adj_mod
	implicit none

  contains

  function igrad1_lop( adj, add, xx, yy)  result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 

    call adjnull( adj, add, xx, yy )
    call igrad1_lop2( adj, xx, yy )
    stat=0
  end function 

  subroutine igrad1_lop2( adj, xx, yy)
    logical,intent(in)   :: adj 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
    integer              :: i

    do i= 1, size(xx)-1  
      if ( adj) then
        xx(i+1) = xx(i+1) + yy(i)
        xx(i  ) = xx(i  ) - yy(i)
      else
        yy(i) = yy(i) + xx(i+1) - xx(i)
      end if
    end do
  end subroutine 

end module 
