! ---------------------------------------------------------------------------
!  scaled_identity.f90 - Created by Morgan Brown
!           Mon Jan 14 17:43:23 2002.
! ---------------------------------------------------------------------------
!       Usage: scaled_identity.mod 
!  Parameters: 
! Description: 
! ---------------------------------------------------------------------------
module scaled_identity

use sep
use adj_mod

implicit none

integer, private, save     :: n1, n2
real, dimension(:) ,private, save  ,     allocatable      :: wt

contains

! ---------------------------------------------------------------------------
	subroutine scaled_identity_init( wt_in, n_in, i_in )
		real , dimension(:), allocatable :: wt_in
		integer             :: n_in,i_in
        if (i_in == 1 ) then
          allocate(wt(n_in))
          write(0,*)"allocate w"
        endif 
		wt = wt_in
	end subroutine scaled_identity_init
! ---------------------------------------------------------------------------

! ---------------------------------------------------------------------------
	integer function scaled_identity_exec( adj, add, model, data)
		logical            :: adj, add 
		real, dimension(:) :: model, data 

		call adjnull( adj, add, model, data)

		if( adj) then
			model = model + data*wt
		else
			data = data + model*wt
		end if

		scaled_identity_exec = 0

	end function scaled_identity_exec
! ---------------------------------------------------------------------------

! ---------------------------------------------------------------------------
	integer function identity_exec( adj, add, model, data)
		logical            :: adj, add 
		real, dimension(:) :: model, data 

		call adjnull( adj, add, model, data)

		if( adj) then
			model = model + data
		else
			data = data + model
		end if

		identity_exec = 0

	end function identity_exec
! ---------------------------------------------------------------------------

end module scaled_identity
