program PreRegRays
  use sep
  use utils_
  implicit none

  integer :: ig,iis1,iis2,it
  integer,allocatable :: iis(:)
  real :: ds,dM,dP,s1f,s2f,stodo
  real, allocatable:: xb(:),zb(:),s(:),x(:,:),z(:,:),xr(:,:),zr(:,:),F1(:,:),F2(:,:)
  complex, allocatable ::mesh(:,:),rays(:,:)
   
  type(myaxis) :: at,ag
  call sep_init()
  call hinaxis(at,1)
  call hinaxis(ag,2)
  call houaxis(at,1)
  call houaxis(ag,2)
  call sep_close()

  allocate( xb(ag%n),zb(ag%n),iis(1),s(ag%n),xr(at%n,ag%n),zr(at%n,ag%n)  )
  allocate( x(at%n,ag%n),z(at%n,ag%n),mesh(at%n,ag%n),rays(at%n,ag%n) )
  allocate( F1(at%n,ag%n),F2(at%n,ag%n)  )
  
  call sep_read(rays)
  xr= real(rays)
  zr=aimag(rays)

  s(1)=0.; ds=0.
  do ig=2,ag%n
     s(ig)=s(ig-1)+sqrt((xr(at%n,ig)-xr(at%n,ig-1))**2+&
                        (zr(at%n,ig)-zr(at%n,ig-1))**2)   
  end do
 
  ds=s(ag%n)/real(ag%n-1);
  xb(1 )=xr(at%n,1   ); zb(1   )=zr(at%n,1   )
  xb(ag%n)=xr(at%n,ag%n); zb(ag%n)=zr(at%n,ag%n)

  do ig=2,ag%n-1
     stodo=real(ig-1)*ds
     iis=minloc(abs(s-stodo))
     iis1=iis(1)
     if (iis1 .eq. 1) then
        iis2=2
     else if (iis1 .eq. ag%n) then
        iis2=ag%n-1
     else
        if (s(iis1) .lt. stodo ) then 
           iis2=iis1+1
        else 
           iis2=iis1-1
        end if
     end if
     s1f = (s(iis1)-stodo)/(s(iis1)-s(iis2) )
     s2f = (stodo-s(iis2))/(s(iis1)-s(iis2) )
     xb(ig)=s2f*xr(at%n,iis1)+s1f*xr(at%n,iis2)
     zb(ig)=s2f*zr(at%n,iis1)+s1f*zr(at%n,iis2)
  end do
  zr(at%n,:)=zb
  xr(at%n,:)=xb

  !! First Stage of Blending function
  do it=1,at%n
     do ig=1,ag%n
        F1(it,ig)=(1-real(it)/real(at%n))*zr(1,ig)+&
                     real(it)/real(at%n) *zr(at%n,ig)
        F2(it,ig)=(1-real(it)/real(at%n))*xr(1,ig)+&
                     real(it)/real(at%n) *xr(at%n,ig)
     end do
  end do

  !! Second Stage of Blending Function
  do it=1,at%n
     do ig=1,ag%n
        z(it,ig)=F1(it,ig)+(1-real(ig)/real(ag%n))*( zr(it,1)   - F1(it,1) )+ &
                              real(ig)/real(ag%n) *( zr(it,ag%n)- F1(it,ag%n) )
        x(it,ig)=F2(it,ig)+(1-real(ig)/real(ag%n))*( xr(it,1)   - F2(it,1) )+ &
                              real(ig)/real(ag%n) *( xr(it,ag%n)- F2(it,ag%n) )
     end do
  end do




!!$  z(:,1   )=zr(:,1   );  
!!$  z(:,ag%n  )=zr(:,ag%n  )
!!$  z(1,:   )=zr(1,:   );  
!!$  z(at%n,:)=zb
!!$  do ig=2,ag%n-1
!!$     z(:,ig) = z(at%n,ig)*  (/(it,it=0,at%n-1)/)/real(at%n-1)    +&
!!$     z(1,ig)*(1-(/(it,it=0,at%n-1)/)/real(at%n-1))
!!$  end do
!!$
!!$  !! Blend the X-coord
!!$  x(:,1   )=xr(:,1   )
!!$  x(:,ag%n)=xr(:,ag%n  )
!!$  x(1,:   )=xr(1,:   )
!!$  x(at%n,:)=xb
!!$  do it=2,at%n-1
!!$     x(it,:) = x(it,ag%n)* ( (/(ig,ig=0,ag%n-1)/)/real(ag%n-1) )    +&
!!$     x(it, 1)*(1- (/(ig,ig=0,ag%n-1)/)/real(ag%n-1) )
!!$  end do

  mesh=cmplx(x,z)

  call sep_write(mesh)
  call exit()
end program PreRegRays
