program RCabcd2_
  use sep
  use utils_

  implicit none

  complex, pointer :: rays(:,:)
  real,    pointer :: x(:,:),z(:,:)
  real,    pointer :: h1(:,:),h2(:,:)
  real,    pointer :: m1(:,:),m2(:,:)
  real,    pointer :: a(:,:),b(:,:),c(:,:),d(:,:)

  type(myaxis) ::at,ag
  integer      ::it,ig,j
  real         ::gx,gz

  real         :: eps,peps

  call sep_init()

  call hinaxis(at,1)
  call hinaxis(ag,2)

  call to_history("esize",4)
  call to_history("n3",4)

  call from_param("peps",peps,0.1)
  call sep_close()

  allocate(rays(at%n,ag%n))
  allocate(  h1 (at%n,ag%n),h2 (at%n,ag%n))
  allocate(  m1 (at%n,ag%n),m2 (at%n,ag%n))
  allocate(   x(at%n,ag%n))
  allocate(   z(at%n,ag%n))
  allocate(   a(at%n,ag%n),b(at%n,ag%n),c(at%n,ag%n),d(at%n,ag%n))

  call sep_read(rays)
  z=aimag(rays)
  x= real(rays)

  !! h1
  do ig=1,ag%n
     gx(1:at%n-1)=( x(2:at%n,ig)-x(1:at%n-2,ig) )/(at%d)
     gz(1:at%n-1)=( z(2:at%n,ig)-z(1:at%n-2,ig) )/(at%d)
     gx(at%n    )=( x(at%n,ig)  -x(at%n-1,ig)   )/(at%d)
     gz(at%n)    =( z(at%n,ig)  -z(at%n-1,ig)   )/(at%d)
     h1(:,ig)=sqrt(gx*gx+gz*gz)
  end do

  !! h2
  do it=1,at%n
        gx(2:ng-1) = (x(it,3:ig)-x(it,1:ig-2))/(2.*ag%d)
        gz(2:ng-1) = (z(it,3:ig)-z(it,1:ig-2))/(2.*ag%d)
        gx(1     ) = (x(it,2   )-x(it,1     ))/(   ag%d)
        gx(ng    ) = (x(it,ng  )-x(it,ng-1  ))/(   ag%d)
        gz(1     ) = (z(it,2   )-z(it,1     ))/(   ag%d)
        gz(ng    ) = (z(it,ng  )-z(it,ng-1  ))/(   ag%d)
        h2(it,:) = sqrt(gx*gx+gz*gz)
  end do


write(0,*) minval(h2),maxval(h2)
  !! m1 = d(h2/h1)/dt = ( d(h2)/dt * h1 - h2 * d(h1)/dt )/ h1^2 
  do it=2,at%n-1
     do ig=1,ag%n
        m1(it,ig)=(h1(it,ig)*(h2(it+1,ig)-h2(it-1,ig))-h2(it,ig)*(h1(it+1,ig)-h1(it-1,ig)))&
        /(2.*at%d*h1(it,ig)*h1(it,ig))
     end do
  end do
  m1(1,:)    = m1(2,:) 
  m1(at%n,:) = m1(at%n-1,:)
  m1(:,1)    = m1(:,2)
  m1(:,ag%n) = m1(:,ag%n-1)

  !! m2 = d(h1/h2)/dg = ( d(h1)/dg * h2 - h1 * d(h2)/dg )/ h2^2 
  do it=1,at%n
     do ig=1+1,ag%n-1
        m2(it,ig)=(h2(it,ig)*(h1(it,ig+1)-h1(it,ig-1))-h1(it,ig)*(h2(it,ig+1)-h2(it,ig-1)))/(2.*ag%d)
     end do
  end do
  m2(:,1)    = m2(:,2)
  m2(:,ag%n) = m2(:,ag%n-1)
  m2(1,:)    = m2(2,:)
  m2(at%n,:) = m2(at%n-1,:)

!  eps=minval(h2)/peps
!  where(abs(h2)<eps)
!    h2=eps
!  end where

  a=1./(h1*h1)
  b=m1/(h1*h2)
  c=m2/(h1*h2*h2*h2)
  d=1./(h2*h2)

  call sep_write(a)
  call sep_write(b)
  call sep_write(c)
  call sep_write(d)

  call exit(0)
end program RCabcd2_









