program RWEmakeswf
  use sep
  implicit none
  integer                            :: nx,nt,nrx,k,nrt,nbeg,ns,nsx
  integer,dimension(:),allocatable   :: iix
  real                               :: dx,ox,ot,dt,orx,drx
  real                               :: drt,ort,dsx,osx
  real, dimension(:), allocatable    :: wavelet
  real, dimension(:,:),allocatable   :: rwfin,rwfout,swfout
  real, dimension(:,:,:),allocatable :: ajs
  complex,dimension(:),allocatable   :: dstopo
  call sep_init()
  call from_aux("topo","n1",nx)
  call from_aux("topo","d1",dx)
  call from_aux("topo","o1",ox)

  call from_aux("wavelet","n1",nt)
  call from_aux("wavelet","o1",ot)
  call from_aux("wavelet","d1",dt)

  call from_history("n1",nrt)
  call from_history("d1",drt)
  call from_history("o1",ort)
  call from_history("n2",nrx)
  call from_history("d2",drx)
  call from_history("o2",orx)
  call from_history("n3",nsx)
  call from_history("d3",dsx)
  call from_history("o3",osx)

  allocate( swfout(nt,nx),iix(1) )
  allocate( wavelet(nt),dstopo(nx) )
  swfout=0.
  write(0,*) 'Rays are at:'
  write(0,*) 'nx',nx,'dx',dx,'ox',ox
  write(0,*) ' '

  call sep_read( rwfin )
  call sreed("wavelet",wavelet,4*nt)
  call sreed("topo",dstopo,8*nx)
  iix=minloc( abs(osx-real(dstopo)) ); 
  ns=iix(1)
write(0,*) osx,real(dstopo(ns))
  write(0,*) 'Source point is at:'
  write(0,*) 'ns',ns,'osx',osx
  write(0,*) ' '
  swfout(1:nt,ns)=wavelet

  call to_history("n1",nt)
  call to_history("o1",ot)
  call to_history("d1",dt)
  call to_history("n2",nx)
  call to_history("o2",ox)
  call to_history("d2",dx)
  call to_history("n3",nsx)
  call to_history("o3",osx)
  call to_history("d3",dsx)
  call to_history("esize",4)
  call hclose()
  call sep_write(swfout)

  call exit()
end program RWEmakeswf
 
