program lloyd
use sep3d_struct_mod
use lloyd_mod
use sep
implicit none
type(sep3d) :: attr_s
real, allocatable :: attr(:,:),ref_attr(:,:),slice(:,:),junk(:,:),scales(:)
integer,allocatable :: iregion(:),nstart(:)
integer :: nref,i,iref,izs,ia,ib,imap,n(4)
logical :: vel_map

call sep_init(SOURCE)

call from_param("nref",nref,20)
call from_param("vel_map",vel_map,.false.)
call init_lloyd();

call init_sep3d("in",attr_s,"INPUT")

n=1
n(1:sep3d_ndims(attr_s))=attr_s%n(1:sep3d_ndims(attr_s))

allocate(scales(n(1)))
allocate(nstart(n(1)))

!! An initial Guess
call from_param("nstart",nstart)

!! Scaling factor
scales=1; call from_param("scales",scales,scales)

allocate(iregion(n(2)*n(3)),junk(n(1),n(2)*n(3)),slice(n(2)*n(3),n(1)), attr(nref,n(1)))

do izs=1,n(4) !! For all depths

   call sreed("in",junk,size(junk)*4)
   slice=transpose(junk)
   do i=1,n(1)
     slice(:,1)=slice(:,1)*scales(i)
   end do
   iref= lloyd_go(slice, attr, nref, iregion,nstart)

   !! Scaling 
   do i=1,n(1) 
     slice(:,1)=slice(:,1)/scales(i)
     attr (:,1)=attr (:,1)/scales(i)
   end do

   if(vel_map) then
     do ib=1,size(junk,2) !! For each nx*ny point
       junk(:,ib)=attr(iregion(ib),:)
     end do
   else
     if(iref < nref) then !! Mask
       attr(iref+1:,:)=-1
     end if
   end if
end do

end program
