program RWEaj_
  use sep
  use util_

  implicit none

  complex, pointer :: rays(:,:)
  real,    pointer :: x(:,:),z(:,:)
  real,    pointer :: h1(:,:),h2(:,:)

  type(myaxis) ::at,ag
  integer      ::it,ig
  real         ::gx,gz

  real         :: eps,peps

  call sep_init()

  call hinaxis(at,1)
  call hinaxis(ag,2)

  call to_history("esize",4)
  call to_history("n3",2)

  call from_param("peps",peps,0.1)
  call sep_close()

  allocate(rays(at%n,ag%n))
  allocate(  h1(at%n,ag%n))
  allocate(  h2(at%n,ag%n))
  allocate(   x(at%n,ag%n))
  allocate(   z(at%n,ag%n))

  call sep_read(rays)
  z=aimag(rays)
  x= real(rays)

  !! h1
  do it=1,at%n-1
     do ig=1,ag%n
        gx = (x(it+1,ig)-x(it,ig))/at%d
        gz = (z(it+1,ig)-z(it,ig))/at%d
        h1(it,ig) = sqrt(gx*gx+gz*gz)
     end do
  end do
  h1(at%n,:) = h1(at%n-1,:)

  !! h2
  do it=1,at%n
     do ig=1+1,ag%n-1
        gx = (x(it,ig+1)-x(it,ig-1))/2/ag%d
        gz = (z(it,ig+1)-z(it,ig-1))/2/ag%d
        h2(it,ig) = sqrt(gx*gx+gz*gz)
     end do
  end do
  h2(:,1)    = h2(:,2)
  h2(:,ag%n) = h2(:,ag%n-1)
  h2(1,:)    = h2(2,:)

  eps=peps*(maxval(abs(h2))+minval(abs(h2)))/2.
  where(abs(h2)<eps)
     h2=eps
  end where

  call sep_write(h1)
  call sep_write(h2)

  call exit(0)
end program RWEaj_









