program RWEprepdat
  use sep
  implicit none
  integer                            :: nx,nt,nrx,k,nrt,nbeg,ns,nsx
  real                               :: dx,ox,ot,dt,orx,drx
  real                               :: drt,ort,dsx,osx
  real, dimension(:), allocatable    :: wavelet
  real, dimension(:,:),allocatable   :: rwfin,rwfout,swfout
  real, dimension(:,:,:),allocatable :: ajs

  call sep_init()
  call from_aux("ajs","n2",nx)
  call from_aux("ajs","d2",dx)
  call from_aux("ajs","o2",ox)
write(0,*) nx,dx,ox
  call from_aux("wavelet","n1",nt)
  call from_aux("wavelet","o1",ot)
  call from_aux("wavelet","d1",dt)

  call from_history("n1",nrt)
  call from_history("d1",drt)
  call from_history("o1",ort)
  call from_history("n2",nrx)
  call from_history("d2",drx)
  call from_history("o2",orx)
  call from_history("n3",nsx)
  call from_history("d3",dsx)
  call from_history("o3",osx)

  allocate( rwfin(nrt,nrx),rwfout(nt,nx),swfout(nt,nx) )
  allocate( wavelet(nt) )
  rwfin=0.;rwfout=0.;swfout=0.
  write(0,*) 'Rays are at:'
  write(0,*) 'nx',nx,'dx',dx,'ox',ox
  write(0,*) ' '

  call sep_read( rwfin )
  call sreed("wavelet",wavelet,4*nt)

  nbeg=floor((osx+orx-ox)/dx)+1
  write(0,*) 'First RWF points at:'
  write(0,*) 'nrx',nbeg,'orx',osx+orx
  write(0,*) ' '

  do k=nbeg,nbeg+nrx
     rwfout(1:nrt,k)=rwfin(1:nrt,k+1-nbeg)/10000.
  end do

  ns=floor( (osx-ox) / dx)+1
  write(0,*) 'Source point is at:'
  write(0,*) 'ns',ns,'osx',osx
  write(0,*) ' '
  swfout(1:nt,ns)=wavelet

  call to_history("n1",nt)
  call to_history("o1",ot)
  call to_history("d1",dt)
  call to_history("n2",nx)
  call to_history("o2",ox)
  call to_history("d2",dx)
write(0,*) nx,ox,dx
  call to_history("n3",nsx)
  call to_history("o3",osx)
  call to_history("d3",dsx)
  call to_history("esize",4)

  call auxputch("n1","i",nt,"swf.H")
  call auxputch("d1","r",dt,"swf.H")
  call auxputch("o1","r",ot,"swf.H")
  call auxputch("n2","i",nx,"swf.H")
  call auxputch("d2","r",dx,"swf.H") 
  call auxputch("o2","r",ox,"swf.H")
  call auxputch("n3","i",nsx,"swf.H")
  call auxputch("d3","r",dsx,"swf.H")
  call auxputch("o3","r",osx,"swf.H")
  call auxputch("esize","i",4,"swf.H")
  call hclose()

  call srite("swf.H",swfout,size(swfout)*4)
  call sep_write(rwfout)

  call exit()
end program RWEprepdat
 
