program RWEconmap
  use SEP
  use conmap
  use conmap_utils
  use prepconmap
  implicit none

  integer                                     :: nx,nt
  real                                        :: dxin,oxin,depthin
  real(KIND=8)                                :: dx  ,ox  ,depth  
  real(KIND=8)                                :: xcent,zcent
  real        , dimension(:),allocatable      :: topoin
  real(KIND=8), dimension(:),allocatable      :: fline,topo,endpoints
  complex        ,dimension(:.:),allocatable  :: zout
  complex(KIND=8),dimension(:),allocatable    :: z
  call sep_init()
  call from_history("n1",nx         ) !! total # of topo samples 
  call from_history("d1",dxin       ) !! total dist b/w topo samples
  call from_history("o1",oxin       ) !! offset of first topo sample
  call from_param("depth",depthin   ) !! Depth extension of grid
  call from_param("nt"  ,nt         ) !! number of depth steps
  call hclose()

  allocate( fline(nx),topo(nx),endpoints(5),z(4*nx+1) )
  allocate( zout(nt,nx) )
  dx=dxin; ox=oxin; depth=depthin;

  !! . . Conformal mapping centers + desamp
  nsamp=5; zcent=depth; 
  xcent=(nx-1)*dx/2.+ox

  call sep_read ( topoin )
  topo=topoin
  fline=(/k,(k=0,nx-1) /)*dx+ox

  !! . . Generate appropriate boundary points
  call prepconmap_init(nx,dx,ox,nsamp,xcent,zcent,depth)
  call prepconmap_main(fline,topo,endpoints,z)

  !! . . Generate conformal map
  call conmap_init(nx,dx,ox,nsamp,xcent,zcent,depth,nt)
  call conmap_main(z,endpoints,zout)

  call hclose()
  call sep_write(zout)
  call exit()
end program RWEconmap
