program MakeSWF
  use SEP
  use LMO_mod
  implicit none

  integer                           :: n1,n2,n3,n4,pad2,m1,m2,m3,ix,n1in,n2in
  integer                           :: mx,qmod,mt,tpfact,xpfact,it
  real                              :: p1,p2,d1,d2,d3,dt,avel,theta,d2in
  real                              :: dx,o1,o2,o3,ot,ox,xloc,o1in,o2in,d1in
  real, dimension(:,:),allocatable  :: modl

  call sep_init()
  call from_param("n1in",n1             ) ! Number of Time Samples
  call from_param("d1in",d1,0.12        ) ! Time sample interval
  call from_param("o1in",o1,0.          ) ! First time loc.
  call from_param("n2in",n2             ) ! Num x-dir samples
  call from_param("d2in",d2,3.          ) ! X-dir spacing
  call from_param("o2in",o2,0.          ) ! X-offset
  call from_param("avel",avel,5.77      ) ! Surface Velocity
  call from_history("p1",p1             ) ! Ray param - x-dir
  call from_history("p2",p2             ) ! Ray param - x-dir
  call from_history("d1",d1             )
  call from_history("d2",d2             )
  call from_history("o1",o1             )
  call from_history("o2",o2             )
  call from_history("n1",n1             )
  call from_history("n2",n2             )
  call to_history("n1",n1               )
  call to_history("n2",n2               )
  call to_history("d1",d1               )
  call to_history("d2",d2               )
  call to_history("o1",o1               )
  call to_history("o2",o2               )

  !! Find Padded Numbers for Complex model
  mt=-floor(o1/d1)-1   !! Time shift
  !! Allocate arrays
  allocate(   modl(n1,n2) )
  modl=0.;   
  !! Linear Moveout  
  do ix=1,n2
     xloc=(o2+d2*(ix-1))
     theta=asin(p1*avel)
     if (p2.lt.0) then
        if (p1.gt.0) then
           it=1.5 + abs(p1)*xloc*tan(theta)/d1+mt
        else
           it=1.5 + abs(p1)*(xloc-(n2-1)*d2)*tan(theta)/d1+mt
        end if
     else
        if (p1.lt.0) then
           it=1.5 + abs(p1)*xloc*tan(theta)/d1+mt
        else
           it=1.5 + abs(p1)*(xloc-(n2-1)*d2)*tan(theta)/d1+mt
        end if
     end if
     modl(it,ix)=1.
  end do

  !! Take real component of model and write out
  call to_history("n1",tpfact*mt  )
  call to_history("n2",xpfact*mx  )
  call to_history("o1",-mt*dt     )
  call to_history("o2",-mx*dx     )
  call hclose()
  call sep_write(real(modl))
  deallocate(modl)

end program MakeSWF
