program Starting_points
  use SEP
  implicit none
  integer                                :: nvz,nx,nw,nvx,i2,iiz,iix,ix,Point
  integer,     dimension(:), allocatable :: ixx,izz,ztmp,xtmp,ntodo
  real                                   :: dvx, dvz, dx, ovx, ovz, ox
  real                                   :: eps, gang, dtau, xx ,zz
  real                                   :: R, anglow, anghigh, xsp, zsp, pi
  real       ,dimension(:  ),allocatable :: x, z, angs
  real       ,dimension(:,:),allocatable :: xsta,zsta
  real       ,dimension(:,:),allocatable :: vel
  complex    ,dimension(:,:),allocatable :: rays
  call sep_init()
  call from_aux("vel","n1",nvz          ) 
  call from_aux("vel","d1",dvz          )
  call from_aux("vel","o1",ovz          )
  call from_aux("vel","n2",nvx          ) 
  call from_aux("vel","d2",dvx          ) 
  call from_aux("vel","o2",ovx          ) 
  call from_param("n1",nx               )  
  call from_param("d1",dx               )
  call from_param("o1",ox               )
  call from_param("dtau",dtau           )
  call from_param("gang",gang,0.        )
  call from_param("anglow" ,anglow,-45. )
  call from_param("anghigh",anghigh,45. )
  call from_param("R",R,100.            )
  call from_param("xsp",xsp,0.          )
  call from_param("zsp",zsp,0.          )
  call from_param("Point",Point         )
  call to_history("n2",nx               )
  call to_history("n1",4                )
  call to_history("d1",dtau             )
  call to_history("o2",anglow           )
  call to_history("o1",1                )
  call to_history("esize",8             )
  allocate( xsta(4,nx),zsta(4,nx)       )
  allocate( x(nvx),z(nvz)               )
  allocate( vel(nvz,nvx)                )
  allocate( rays(4,nx)                  )
  allocate( ixx(nx), izz(nx),ntodo(nx)  )
  allocate( angs(nx),ztmp(1),xtmp(1)    )
  call sep_read( vel,"vel"              )

  !! . . Parameter setup
  pi=acos(-1.)

  !! . . Allocate large grid model points
  allocate( ixx(nvx),izz(nvz) )
  ixx(1:nvx) = (/ (i2,i2=1,nvx) /)  
  izz(1:nvz) = (/ (i2,i2=1,nvz) /) 
  x=dble((ixx-1)*dvx+ovx)               
  z=dble((izz-1)*dvz+ovz) 

  !! . . Plane or point?
  if (Point .eq. 0) then  !! . . Use a plane
     write(0,*) 'USING PLANE'
     write(0,*) 'Grid angle is: ',gang

     if (gang .gt. 0.) then
        do i2=1,nx
           xsta(1,i2) = xsp + ((i2-1)*dx)*abs(cos(gang/180.*pi)) 
           zsta(1,i2) = zsp - ((i2-1)*dx)*abs(sin(gang/180.*pi))  
        end do
     else 
        do i2=1,nx
           xsta(1,i2) = xsp + (nx-1)*dx - ((nx-i2)*dx)*abs(cos(gang/180.*pi)) 
           zsta(1,i2) = zsp - ((nx-i2)*dx)*abs(sin(gang/180.*pi))  
        end do
     end if
     !! . . Construct 2nd - 4th grid steps
     do i2=2,4
        do ix=1,nx
           xtmp=minloc(abs(x-xsta(i2-1,ix))); iix=xtmp(1)
           ztmp=minloc(abs(z-zsta(i2-1,ix))); iiz=ztmp(1)
           if (iiz .lt. 1) then
              iiz=1
              xsta(i2,ix) = xsta(i2-1,ix) + dtau*sin(gang/180.*pi)*1000
              zsta(i2,ix) = zsta(i2-1,ix) + dtau*cos(gang/180.*pi)*1000  
           else
              xsta(i2,ix) = xsta(i2-1,ix) + dtau*sin(gang/180.*pi)*vel(iiz,iix)
              zsta(i2,ix) = zsta(i2-1,ix) + dtau*cos(gang/180.*pi)*vel(iiz,iix)
           end if
        end do
     end do

!!$     do i2=1,nx
!!$          xsta(1,i2) = xsp + ((i2-1)*dx)
!!$          zsta(1,i2) = zsp  
!!$     end do
!!$     !! . . Construct 2nd - 4th grid steps
!!$     do i2=2,4
!!$        do ix=1,nx
!!$           xtmp=minloc(abs(x-xsta(i2-1,ix))); iix=xtmp(1)
!!$           ztmp=minloc(abs(z-zsta(i2-1,ix))); iiz=ztmp(1)
!!$           xsta(i2,ix) = xsta(i2-1,ix) + dtau*sin(gang/180.*pi)*vel(iiz,iix)
!!$           zsta(i2,ix) = zsta(i2-1,ix) + dtau*cos(gang/180.*pi)*vel(iiz,iix)  
!!$        end do
!!$     end do

     call to_history("d2",dx)

  else !! . . Use a circle
     write(0,*) 'USING Circle'

     ntodo = (/ (i2, i2=0,nx-1) /)  
     angs  = (anghigh-anglow)*pi/(180*(nx-1))*ntodo+anglow*pi/180+pi/2
     call to_history("d2",(angs(2)-angs(1))*R   )
     xsta(1,:)=R*cos( angs -pi ) + xsp
     zsta(1,:)=R*sin( angs ) + zsp
     do i2=2,4
        do ix=1,nx
           xtmp=minloc(abs(x-xsta(i2-1,ix))); iix=xtmp(1)
           ztmp=minloc(abs(z-zsta(i2-1,ix))); iiz=ztmp(1)
           xsta(i2,ix)=(dtau*vel(iiz,iix)+sqrt( (xsta(i2-1,ix)-xsp)**2+&
           (zsta(i2-1,ix)-zsp)**2))*cos( angs(ix) -pi ) + xsp
           zsta(i2,ix)=(dtau*vel(iiz,iix)+sqrt( (xsta(i2-1,ix)-xsp)**2+&
           (zsta(i2-1,ix)-zsp)**2))*sin( angs(ix) ) + zsp
        end do
     end do

  end if

  !! . . Output ray file
  rays=cmplx(xsta,zsta)
  call sep_write(rays)  

  deallocate(xsta,zsta,x,z,vel,rays,ixx,izz,angs)
end program Starting_points
