program Statshift
  use SEP
  implicit none 
  integer                                   :: n1,n2,n3,esize,iw,m1,ix,jj,pad2		
  real, dimension(:,:,:) , allocatable      :: data,modl
  complex, dimension(:,:), allocatable      :: cdata,cmodl
  real, dimension(:,:)   , allocatable      :: tmp
  real                                      :: w0,dw,pi,d1,w,tshift,sig1
  call sep_init()
  call from_history("n1"    ,n1          )
  call from_history("n2"    ,n2          )
  call from_history("n3"    ,n3          )
  call from_history("d1"    ,d1          )
  call from_history("esize" ,esize       )
  call from_param  ("tshift",tshift      )
  call hclose()
  allocate( modl(n1,n2,n3), data(n1,n2,n3) )
  allocate( tmp(n1,n2)                     )
  modl=0.;data=0.;

  !! Ensure we have real data
  if(esize.ne.4) call erexit('esize !=4')
  m1=pad2(n1)
  allocate( cmodl(m1,n2),   cdata(m1,n2)   )
  cmodl=cmplx(0.,0.);
  cdata=cmplx(0.,0.);

  !! . . Definitions
  pi = 3.14159265; sig1 = +1.;
  w0=-pi/d1;  dw=2.*pi/(m1*d1);

  !! . . Read in File
  call sep_read( data )
  do jj=1,3
     cdata(1:n1,1:n2)=cmplx(data(1:n1,1:n2,jj),0.)
     call ft1axis(0,sig1,m1,n2,cdata)
     do ix=1,n2
        do iw=1,m1
           w=w0+(iw-1)*dw
           cmodl(iw,ix)=cdata(iw,ix)*exp(cmplx(0.,-w*tshift))
        end do
     end do
     call ft1axis(1,sig1,m1,n2,cmodl)
     tmp=real(cmodl)
     modl(1:n1,1:n2,jj)=tmp(1:n1,1:n2)
  end do

  !! . . Output file
  call sep_write(modl)
  deallocate(tmp,cmodl,cdata,data,modl)

end program Statshift
