program Prepconmap
  use sep
  implicit none
  integer                            :: nx,i,j,k,cnt,ns
  integer,dimension(:),allocatable   :: revx
  real                               :: xcent,ycent,depth,ox,dx
  real                               :: addon,dsl,dsr
  real,dimension(:),allocatable      :: points,tline,rline,lline,bline
  complex, dimension(:),allocatable  :: z,endpoints,zrs,zls,ztop,zbot

  call sep_init()
  call from_history("n1",nx         )  
  call from_history("d1",dx         )  
  call from_history("o1",ox         )  
  call from_param("xcent",xcent     ) !! x-axis center of circle mapping
  call from_param("ycent",ycent     ) !! y-axis center of circle mapping
  call from_param("depth",depth     ) !! Depth extension of grid
  call from_param("ns",ns,50        ) !! # of side pad points
  call from_param("addon",addon,250.) !! end add on points
  call to_history("n1"   ,2*nx+2*ns)  
  call to_history("o1"   ,ox)  
  call to_history("d1"   ,dx)
  call to_history("esize",8 )
  call auxputch("n1","i",5,"endpoints.H")
  call auxputch("esize","i",8,"endpoints.H")
  call hclose()

  allocate( ztop(nx),zbot(nx),zrs(ns),zls(ns),z(2*nx+2*ns) )
  allocate( points(nx),endpoints(5) )
  allocate( tline(nx),rline(ns),bline(nx),lline(ns),revx(nx) )
  lline=0.
  !! . . Read in points
  call sep_read ( points )

  dsl=2.*(depth-points(nx))/(ns-1)
  dsr=2.*(depth-points(1 ))/(ns-1)

  tline(1:nx)= (/ (k,k=0,nx-1)/)*dx+ox
  rline(1:ns)= (/ (k,k=0,ns-1)/)*dsl+points(nx)
  bline(1:nx)= (/ (k,k=nx-1,0,-1)/)*dx+ox
  lline(1:ns)= (/ (i,i=ns-1,0,-1)/)*dsr+points(1) 
  revx (1:nx)= (/ (k,k=nx,1,-1)/)

  !! . . Pad 
  ztop=cmplx(tline,points)
  zrs =cmplx(tline(nx)+addon,rline)
  zbot=cmplx(bline,2.*depth-points(revx))
  zls =cmplx(tline(1 )-addon,lline)

  z(1        :nx       )=ztop
  z(nx+1     :nx+ns    )=zrs
  z(nx+ns+1  :2*nx+ns  )=zbot
  z(2*nx+1+ns:2*nx+2*ns)=zls

  endpoints(1) = zrs(1)  
  endpoints(2) = zrs(ns)
  endpoints(3) = zls(1)
  endpoints(4) = zls(ns)
  endpoints(5) = cmplx(xcent,ycent)

  !! . . Output two data files
  call sep_write(z)
  call sep_write(endpoints,"endpoints.H",5,8)
  deallocate( ztop,zbot,zrs,zls,z,points,endpoints )
  deallocate( tline,rline,bline,lline,revx )
end program Prepconmap
