program PrepconmapNL
  use sep
  implicit none
  integer                            :: nx,i,j,k,cnt,nsamp,ns
  integer,dimension(:),allocatable   :: revx,nsline,endline
  real                               :: xcent,ycent,depth,ox
  real                               :: dsl,dsr,dy,dx,dsy,dsx
  real,dimension(:),allocatable      :: points,tline,rline,lline,bline
  real,dimension(:),allocatable      :: yvals,endvals
  complex, dimension(:),allocatable  :: z,endpoints,zrs,zls,ztop,zbot
  complex, dimension(:),allocatable  :: pointsin

  call sep_init()
  call from_history("n1",nx         )  
  call from_history("d1",dx         )  
  call from_history("o1",ox         )  
  call from_param("xcent",xcent     ) !! x-axis center of circle mapping
  call from_param("ycent",ycent     ) !! y-axis center of circle mapping
  call from_param("depth",depth     ) !! Depth extension of grid
  call from_param("desamp",nsamp,5  )
  call to_history("n1"   ,4*nx)  
  call to_history("o1"   ,ox)  
  call to_history("d1"   ,dx)
  call to_history("esize",8 )
  call auxputch("n1","i",5,"endpoints.H")
  call auxputch("esize","i",8,"endpoints.H")
  call hclose()

  allocate( ztop(nx),zbot(nx),zrs(ns),zls(ns),z(4*nx) )
  allocate( points(nx),endpoints(5),nsline(nsamp),tline(nx) )
  allocate( yvals(nsamp),pointsin(nx) )

  !! . . Read in points
  call sep_read ( pointsin )
  points=aimag(pointsin)
  tline=real(pointsin)

  !! . . Interpolate top points
  do i=1,nx-nsamp,nsamp
     nsline=(/ (j,j=i,i+nsamp-1) /)
     dsy=points(nsline(nsamp))-points(nsline(1))
     dsx=tline (nsline(nsamp))-tline (nsline(1))
     yvals=dsy/dsx*(nsline-nsline(1))*dx+points(nsline(1))
     z(nsline)=cmplx(tline(nsline),yvals)
  end do

  allocate( endline(nx+1-i), endvals(nx+1-i) )
  endline=(/ (j,j=i,nx) /)
  dsy=points(endline(size(endline)))-points(endline(1))
  dsx=tline (endline(size(endline)))-tline (endline(1))
  endvals=dsy/dsx*(endline-endline(1))*dx+points(endline(1))
  z(endline)=cmplx(tline(endline),endvals)
  deallocate (endline,endvals)

  !! . . Right side
  dsr=2.*(depth-points(nx))/(nx-1)
write(0,*) points(nx),dsr
  do i=1,nx
    z(nx+i)=cmplx(tline(nx)+dx,dble(i-1)*dsr+points(nx))
  end do

  !! . . Bottom points
  cnt=1
  do i=nx,1,-1
    z(2*nx+cnt)=conjg(z(i))+cmplx(0.,2.*depth)
  cnt=cnt+1
  end do

  !! . . Left side
  dsl=2.*(depth-points(1))/(nx-1)
  cnt=1
  do i=nx,1,-1
    z(3*nx+cnt)=cmplx(tline(1)-dx,dble(i-1)*dsl+points(1))
    cnt=cnt+1
  end do

  endpoints(1) = z(nx+1  )
  endpoints(2) = z(2*nx  )
  endpoints(3) = z(3*nx+1)
  endpoints(4) = z(4*nx  )  
  endpoints(5) = cmplx(xcent,ycent)

  !! . . Output two data files
  call sep_write(z)
  call sep_write(endpoints,"endpoints.H",5,8)
  call exit()
end program PrepconmapNL
