program Prepconmap
  use sep
  implicit none
  integer                            :: nx,k,ns
  real                               :: xcent,ycent,depth,ox,dx
  real                               :: addon,dsl,dsr,dsb
  real,dimension(:),allocatable      :: points,tline,rline,lline,bline
  complex, dimension(:),allocatable  :: z,endpoints,zrs,zls,ztop,zbot

  call sep_init()
  call from_history("n1",nx         )  
  call from_history("d1",dx         )  
  call from_history("o1",ox         )  
  call from_param("xcent",xcent     ) !! x-axis center of circle mapping
  call from_param("ycent",ycent     ) !! y-axis center of circle mapping
  call from_param("depth",depth     ) !! Depth extension of grid
  call from_param("ns",ns,50        ) !! # of side pad points
  call from_param("addon",addon,250.) !! end add on points
  call to_history("n1"   ,nx+3*ns)  
  call to_history("o1"   ,ox)  
  call to_history("d1"   ,dx)
  call to_history("esize",8 )
  call auxputch("n1","i",5,"endpoints.H")
  call auxputch("esize","i",8,"endpoints.H")
  call hclose()

  allocate( ztop(nx),zbot(nx),zrs(ns),zls(ns),z(nx+3*ns) )
  allocate( points(nx),endpoints(5) )
  allocate( tline(nx),rline(ns),bline(ns),lline(ns) )
  lline=0.
  !! . . Read in points
  call sep_read ( points )

  dsl=(depth-points(nx))/(ns-1)
  dsr=(depth-points(1 ))/(ns-1)
  tline(1:nx)= (/ (k,k=0,nx-1)/)*dx+ox
  dsb=(tline(nx)-tline(1))/(ns-1)
  rline(1:ns)= (/ (k,k=0,ns-1)/)*dsl+points(nx)
  bline(1:ns)= (/ (k,k=ns-1,0,-1)/)*dsb+ox
  lline(1:ns)= (/ (k,k=ns-1,0,-1)/)*dsr+points(1) 


  !! . . Pad 
  ztop=cmplx(tline          ,points  )
  zrs =cmplx(tline(nx)+addon,rline   )
  zbot=cmplx(bline          ,depth)
  zls =cmplx(tline(1 )-addon,lline   )

  z(1        :nx     ) = ztop
  z(nx+1     :nx+ns  ) = zrs
  z(nx+ns+1  :nx+2*ns) = zbot
  z(nx+1+2*ns:nx+3*ns) = zls

  endpoints(1) = zrs(1)  
  endpoints(2) = zrs(ns)
  endpoints(3) = zls(1)
  endpoints(4) = zls(ns)
  endpoints(5) = cmplx(xcent,ycent)

  !! . . Output two data files
  call sep_write(z)
  call sep_write(endpoints,"endpoints.H",5,8)
  deallocate( ztop,zbot,zrs,zls,z,points,endpoints )
  deallocate( tline,rline,bline,lline )
end program Prepconmap
