program dx2ds
  use sep
  implicit none
  integer :: nt,nx,ns
  integer :: adj
  integer,allocatable::iix(:)
  real    :: dt,dx,ds
  real    :: ot,ox,os,oshot
  integer :: ix,ii
  real    :: xt,xm,xp,wxm,wxp
  complex, allocatable:: dstopo(:)
  real   , allocatable:: dswf(:,:),dxwf(:,:),dxin(:),xline(:)

  call sep_init()
  call from_history("n1",nt)
  call from_history("o1",ot)
  call from_history("d1",dt)
  call from_history("n2",nx)
  call from_history("o2",ox)
  call from_history("d2",dx)
  call from_history("o3",oshot)
  call from_aux("topo","n1",ns)
  call from_aux("topo","o1",os)
  call from_aux("topo","d1",ds)
  call from_param("adj",adj,1)
  allocate( dstopo(ns),xline(nx) )
  allocate( dxwf(nt,nx), dswf(nt,ns),iix(1)  )

  call sreed("topo",dstopo,ns*8)
  xline=(/ (ii,ii=0,nx-1) /)*dx+ox+oshot
write(0,*) xline(1),xline(nx)
  if (adj==1) then!! From dx to ds
     call sep_read(dxwf)
     do ii=1,ns
        xt  = real(dstopo(ii))
        iix = minloc(abs(xt-xline))
        ix  = iix(1)
        if (xt-xline(ix) .lt. 0. ) ix=ix-1
        xm  = abs(xt-xline(ix))
        xp  = abs(xline(ix+1)-xt)
        wxm = (1.0-xp/dx)
        wxp = (1.0-xm/dx)
        if (ix .lt. nx .and. ix .gt.1) then
           dswf(:,ii) = wxm*dxwf(:,ix) + wxp*dxwf(:,ix+1)
        else
           dswf(:,ii)=0.
        end if
     end do
     call to_history("n1",nt)
     call to_history("d1",dt)
     call to_history("o1",ot)
     call to_history("n2",ns)
     call to_history("d2",ds)
     call to_history("o2",os)
     call to_history("esize",4)
     call hclose()
     call sep_write(dswf)
  else 
     call sep_read(dswf)
        do ii=1,nx
          xt  = xline(ii)
          ix  = ceiling((xt-os)/ds)
          xm  = xt-real(dstopo(ix))
          xp  = real(dstopo(ix+1))-xt
          wxm = (1.0-xp/ds)
          wxp = (1.0-xm/ds)
          dxwf(:,ii) = wxm*dswf(:,ix) + wxp*dswf(:,ix+1)
       end do
     call to_history("n1",nt)
     call to_history("d1",dt)
     call to_history("o1",ot)
     call to_history("n2",nx)
     call to_history("d2",dx)
     call to_history("o2",ox)
     call hclose()
     call sep_write(dxwf)
  end if
  call exit()
end program dx2ds
