module rotate2PSVx
  use SEP
  implicit none
  integer                        :: n1,n2,n3
  real                           :: alpha,beta,p1,p2

contains
  subroutine rec2PS_init(n1_in,n2_in,n3_in,a_in,b_in,p1_in,p2_in)


  end subroutine rec2PS_init

  subroutine rec2PS(adj,add,data,modl)
    !! . . Declarations
    integer                      :: n1,n2,n3,ii,jj
    real                         :: alpha,beta,Frp,Fzp,Frsv,Fzsv,qa,qb,delta,p1,p2
    real, dimension(n1,n2,n3)    :: data,modl

    !! . . Constant Definitions
    qa=sqrt(1 / (alpha*alpha) - slow**2)
    qb=sqrt(1 / (beta * beta) - slow**2)
    delta = 1 - 4*slow**2*beta**2 + 4*slow**4*beta**4 + 4*beta**4*slow**2*qa*qb
    Frp=4*alpha*beta**2*slow*qa*qb/delta
    Fzp=-2*alpha*qa*(1-2*slow**2*beta**2)/delta
    Frsv=2*beta*qb*(1-2*slow**2*beta**2)/delta
    Fzsv=4*beta**3*slow*qa*qb/delta
    !! . . Rotate Section a la Kennett 1991
    do ii=1,n1 
      do jj=1,n2 
     !!   write(0,*) data
        modl(ii,jj,1)=Frp*data(ii,jj,1) + Fzp* data(ii,jj,2)
         modl(ii,jj,2)=Frsv*data(ii,jj,1) + Fzsv*data(ii,jj,2)
       end do
    end do
  end subroutine rotate2PSV1
end module rotate2PSVx


