module ttray_mod
  use sep 
  use igrad1
  implicit none
  integer     ,private   :: nx, nz, nw, nvx, nvz, nwx, nwz,maxnum,nray
  real(KIND=8),private   :: dx ,dw ,ox ,ow ,dvz ,dvx ,ovz ,ovx, dz, oz 
  real(KIND=8),private   :: dwz ,dwx ,owx ,owz
  real(KIND=8),private   :: eps, dtau
contains
  !######################################################################
  subroutine ttray_init(nz_in,nx_in,nw_in,dz_in,dx_in,dw_in,oz_in,ox_in,&
        ow_in,nvx_in,nvz_in,dvx_in,dvz_in,ovx_in,ovz_in,nwx_in,nwz_in,dwx_in,&
        dwz_in,owx_in,owz_in,dtau_in,eps_in,maxnum_in)
  integer        :: nx_in, nz_in, nw_in, nvx_in, nvz_in, nwx_in, nwz_in,maxnum_in, nray_in
  real(KIND=8)   :: dx_in ,dw_in ,ox_in ,ow_in ,dvz_in ,dvx_in ,ovz_in ,ovx_in
  real(KIND=8)   :: dwz_in ,dwx_in ,owx_in ,owz_in, dz_in, oz_in
  real(KIND=8)   :: eps_in, dtau_in
  nx=nx_in;   nz=nz_in;   nw=nw_in;   nvx=nvx_in; nvz=nvz_in; nwx=nwx_in; nwz=nwz_in
  dx=dx_in;   dw=dw_in;   ox=ox_in;   ow = ow_in; dvz=dvz_in; dvx=dvx_in; ovz=ovz_in
  ovx=ovx_in; dwz=dwz_in; dwx=dwx_in ;owx=owx_in; owz=owz_in; eps=eps_in; dtau=dtau_in
  maxnum=maxnum_in; nray=nray_in;dz=dz_in
  end subroutine ttray_init
  !######################################################################
  subroutine ttray(vel,data,rays,x,z,xsta,zsta)
    integer                                     :: ip,itau,iix,iiz
    real(KIND=8)                                :: dx_step,dz_step,ds,K
    real(KIND=8)   ,dimension(:  )              :: xsta,zsta,x,z
    real(KIND=8)   ,dimension(:,:),allocatable  :: PoverP_dx,PoverP_dz,vel,xray,zray
    real(KIND=8),dimension(:,:)                 :: data
    complex(KIND=8),dimension(:,:)              :: rays

    allocate(PoverP_dx(nwz,nwx),PoverP_dz(nwz,nwx))
    allocate(xray( maxnum,nx),zray(maxnum,nx))

    call get_gradx(data,PoverP_dx)
    call get_gradz(data,PoverP_dz)

    xray(1,1:nx)=xsta;  zray(1,1:nx)=zsta
write(0,*) 'got to here'
write(0,*) 'got to here'
    do itau=2, maxnum
!       write(0,*) 'Working on step ',itau, maxnum
       do ip=1,nx
          iix=floor( (xray(itau-1,ip)-ovx)/dvx + 1.5 )
          iiz=floor( (zray(itau-1,ip)-ovz)/dvz + 1.5 )
          if (iix .lt. 1) then
             iix=1
          elseif (iix .gt. nvx) then
             iix=nwx
          end if
          if (iiz .lt. 1) then
             iiz=1
          elseif (iiz .gt. nvz) then
             iiz=nvz
          end if
!          ds=-sqrt(vel(iiz,iix))*dtau
!          ds=sqrt(vel(iiz,iix))*dtau
          ds=vel(iiz,iix)*dtau
!          ds=dtau
!          dx_step= PoverP_dz(iiz,iix)
!          dz_step=-PoverP_dx(iiz,iix)
          dx_step=PoverP_dx(iiz,iix)
          dz_step=PoverP_dz(iiz,iix)
          K=dsqrt(dx_step**2+dz_step**2)
          xray(itau,ip)=xray(itau-1,ip)+ds*dx_step/K
          zray(itau,ip)=zray(itau-1,ip)+ds*dz_step/K
!          xray(itau,ip)=xray(itau-1,ip)-ds*dx_step
!          zray(itau,ip)=zray(itau-1,ip)-ds*dz_step
!write(0,*) dx_step/K
       end do
!write(0,*) 'Indicies: ',iix,iiz,itau
!write(0,*) 'Prev.sta: ',xray(itau-1,ip-1),zray(itau-1,ip-1)
!write(0,*) 'Add ons : ',-ds*dx_step/K,-ds*dz_step/K
    end do
    rays=cmplx(xray,zray) 
    deallocate(PoverP_dx,PoverP_dz,xray,zray)
  end subroutine ttray
  !####################################################################
  subroutine model_points(x,z)
    integer                                    :: i2
    integer,         dimension(:), allocatable :: ixx,izz
    real(KIND=8),    dimension(:)              :: x,z
    allocate( ixx(nvx),izz(nvz) )
    ixx(1:nvx) = (/ (i2,i2=1,nvx) /)  
    izz(1:nvz) = (/ (i2,i2=1,nvz) /) 
    x=dble((ixx-1)*dvx+ovx)               
    z=dble((izz-1)*dvz+ovz)
    deallocate(ixx,izz)
  end subroutine model_points
  !####################################################################
  subroutine get_gradx(data,PoverP_dx)
    integer                                 :: iz,stat
    real        ,dimension(:)  ,allocatable :: rtemp
    real        ,dimension(:,:),allocatable :: data1
    real(KIND=8),dimension(:,:)             :: data,PoverP_dx
    allocate( rtemp(nwx),data1(nwz,nwx) )
    data1=data
    do iz=1,nwz
       stat=igrad1_lop(.false.,.false.,data1(iz,:),rtemp)
       PoverP_dx(iz,:)=rtemp
    end do
    write(0,*) 'COMPUTED x gradient'
    deallocate (rtemp,data1 )
  end subroutine get_gradx
  !######################################################################
  subroutine get_gradz(data,PoverP_dz)
    integer                                   :: ix,stat
    real           ,dimension(:)  ,allocatable:: rtemp
    real(kind=8)   ,dimension(:,:)            :: PoverP_dz,data
    real           ,dimension(:,:),allocatable:: data1
    allocate( rtemp(nwz),data1(nwz,nwx) )
    data1=data
    do ix=1,nwx
       stat=igrad1_lop(.false.,.false.,real( data1(:,ix)),rtemp )
       PoverP_dz(:,ix)=rtemp
    end do
    write(0,*) 'COMPUTED z gradient'
    deallocate( rtemp,data1 )
  end subroutine get_gradz
  !######################################################################
end module ttray_mod
